#include "point.h"

const double Point::INF = 1e12;
Point        Point::nil = Point(Point::INF, Point::INF, Point::INF);
Point* const Point::NIL = &nil;

Point::Point()
{
    setPoint(0, 0, 0);
    next = prev = 0;
    red = green = blue = 0.0f;
}

Point::Point(double x, double y, double z)
{
    setPoint(x, y, z);
    next = prev = 0;
    red = green = blue = 0.0f;
}

void Point::setPoint(double x, double y, double z)
{
    this->glcoords[0] = x;
    this->glcoords[1] = y;
    this->glcoords[2] = z;
}

void Point::addremove()
{
    // the point as a prev and next pointer, which is it's previous and next element in the list
    // if the Point is still inside the list, then drop it out
    if (prev->next == this) {
        prev->next = next;
        next->prev = prev;
    }
    // if the point is not inside the list, then add it back between its own prev and next
    else {
        prev->next = this;
        next->prev = this;
    }
}
